LeetCode-TwoSum(easy)-for Java,C++,Python-Day01

题目

Given an array of integers, find two numbers such that they 
add up to a specific target number.

The function twoSum should return indices of the two numbers 
such that they add up to the target, where index1 must be less 
than index2. Please note that your returned answers (both index1 
and index2) are not zero-based.

You may assume that each input would have exactly one solution.

Input: numbers={2, 7, 11, 15}, target=9
Output: index1=1, index2=2
  • Java
import java.util.HashMap;
import java.util.Map;

public class TwoSum {
    /**
	 * Given an array of integers, return indices of the two numbers such that they add up to a specific target.

		You may assume that each input would have exactly one solution.

		Example: 
		Given nums = [2, 7, 11, 15], target = 9,

		Because nums[0] + nums[1] = 2 + 7 = 9, 
		return [0, 1].
	 */

	public static void main(String[] args) {
		TwoSum t = new TwoSum();
		int[] numbers = {3,2,4};
		int target = 6;
		int[] res = t.twoSum(numbers, target);
		for(int i = 0 ; i < res.length; i++) {
			System.out.print(i == res.length - 1?res[i]:res[i]+",");
		}
	}
	
	public int[] twoSum(int[] numbers,int target) {
		Map<Integer, Integer> map = new HashMap<Integer,Integer>();
		for(int i = 0; i < numbers.length; i++) {// put all numbers to the map
			map.put(numbers[i], i);
		}
		
		for(int i = 0 ; i < numbers.length; i++) {
			int newtarget = target - numbers[i];
			if(map.containsKey(newtarget) && i != map.get(newtarget)) {
				return new int[] {i+1,map.get(newtarget) + 1};
			}
		}
		
		return null;
	}
}

运行结果:
java运行结果

  • C++
#include<iostream>
#include<vector>
using namespace std;

/**
 * Given an array of integers, return indices of the two numbers such that they add up to a specific target.

    You may assume that each input would have exactly one solution.

    Example: 
    Given nums = [2, 7, 11, 15], target = 9,

    Because nums[0] + nums[1] = 2 + 7 = 9, 
    return [0, 1].
 */

class Solution{
public:
    vector<int> TwoSum(vector<int>& numbers,int target)
    {
        vector<int> result;
        int sum = 0;
        for(int i = 0 ; i < numbers.size(); i++)
        {
            for(int j = i + 1 ; j < numbers.size() ; j++)
            {
                sum = numbers[i] + numbers[j];
                if(sum == target)
                {
                    result.push_back(i+1);
                    result.push_back(j+1);
                    break;
                }
            }
        }

        return result;
    }
};

int main(void)
{
    vector<int> numbers;
    numbers.push_back(2);
    numbers.push_back(7);
    numbers.push_back(11);
    numbers.push_back(15);
    int target = 18;
    vector<int> result;
    Solution res;
    result = res.TwoSum(numbers,target);
    for(int i = 0 ; i < result.size(); i++)
    {
        if(i != result.size() - 1)
            cout<<result[i]<<",";
        else
            cout<<result[i]<<endl;
    }
    
    return 0;
}

运行结果:
C++运行结果

  • Python
    class Solution(object):
    """
    :type nums:List[int]
    :type target:int
    :rtype: List[int]
    """
        def twoSum(self,nums,target):
            num_to_index = {}   # key is number,value is index in nums
            for i,num in enumerate(nums):
                if target - num in num_to_index:
                    return [i,num_to_index[target-num]]

                num_to_index[num] = i
            return [] # no sum


    if __name__ == '__main__':  
    TwoSum = Solution()                                  
    nums = [2,7,11,15,1,3,53,245]
    print TwoSum.twoSum(nums,56)
    ```
  2. 
    ```
    class Solution(object):
    """
    :type nums:List[int]
    :type target:int
    :rtype: List[int]
    """
        def twoSum(self,nums,target):
            for i,num in enumerate(nums):
                if target - num in nums and nums[i] != target - num:
                    return [i,nums.index(target - num)]
            return [] # no sum


    if __name__ == '__main__':  
        TwoSum = Solution()                                  
        nums = [2,7,11,15,1,3,53,245]
        print TwoSum.twoSum(nums,56)
    
    ```
    3. 
    ```
    class Solution:
        def twoSum(self,nums,target):
            size = len(nums)
            for i in range(size):
                for j in range(i+1,size):
                    if(nums[i] + nums[j] == target):
                        return i,j
            return 0,0

    if __name__ == "__main__":
        nums = [2,7,11,15,1,3,53,245]
        TwoSum = Solution()
        print TwoSum.twoSum(nums,56)
    ```
运行结果:
![Python运行结果](https://upload-images.jianshu.io/upload_images/4077777-ed24c821643cad02.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240)

> 总结:因为题中说明了只有一对答案,因此不需要考虑重复的情况。三种语言实现的基本思路都是相同的。
>1. 先确定第一个数,然后用目标数减去这个数,判断减去的结果是否在原数组中,如果在,就返回他们的索引。
>2. 先确定一个数,然后在这个数之后的数中选一个,如果这连个数相加为目标数,则返回他们的索引。
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
LeetCode-Editor是一种在线编码工具,它提供了一个用户友好的界面编写和运行代码。在使用LeetCode-Editor时,有时候会出现乱码的问题。 乱码的原因可能是由于编码格式不兼容或者编码错误导致的。在这种情况下,我们可以尝试以下几种解决方法: 1. 检查文件编码格式:首先,我们可以检查所编辑的文件的编码格式。通常来说,常用的编码格式有UTF-8和ASCII等。我们可以将编码格式更改为正确的格式。在LeetCode-Editor中,可以通过界面设置或编辑器设置来更改编码格式。 2. 使用正确的字符集:如果乱码是由于使用了不同的字符集导致的,我们可以尝试更改使用正确的字符集。常见的字符集如Unicode或者UTF-8等。在LeetCode-Editor中,可以在编辑器中选择正确的字符集。 3. 使用合适的编辑器:有时候,乱码问题可能与LeetCode-Editor自身相关。我们可以尝试使用其他编码工具,如Text Editor、Sublime Text或者IDE,看是否能够解决乱码问题。 4. 查找特殊字符:如果乱码问题只出现在某些特殊字符上,我们可以尝试找到并替换这些字符。通过仔细检查代码,我们可以找到导致乱码的特定字符,并进行修正或替换。 总之,解决LeetCode-Editor乱码问题的方法有很多。根据具体情况,我们可以尝试更改文件编码格式、使用正确的字符集、更换编辑器或者查找并替换特殊字符等方法来解决这个问题。
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值